
#include <stdio.h>
#include <stdlib.h>

#include <math.h>
#include <pic.h>
#ifndef _XTAL_FREQ
#define _XTAL_FREQ 4000000
#endif
//pic16f873a
/*     010 */

__CONFIG(DEBUGDIS & UNPROTECT & LVPDIS & BORDIS & PWRTEN & WDTDIS & XT & DUNPROT);

#define BITNUM(adr,bit)((unsigned)(&adr)*8+(bit)) // -.
#define ON 1                                      // -  .
#define OFF 0                                     // -  .
unsigned char BUF;
unsigned char BUFP;
unsigned char BUFL;
unsigned char BUFI;
 char BUFK;
unsigned char BLLD;
unsigned char BUFB;
unsigned char BUFC;
unsigned char BUFD;
unsigned char BUFE;
unsigned char BUFF;
unsigned char BUFRRP;
unsigned char BUFREP; // 
unsigned char REPREP;
unsigned char i;
int DREBEZ;

unsigned long fzin;

 void low_init();
 void OPROSKL(void);
 void OPROSUP(void);
 void APOISKZ(void);
 void OPRRAB(void);
  
static bit DA0  @ BITNUM(PORTA,0); //. 
static bit DA1  @ BITNUM(PORTA,1); // +      DA1=1
static bit DA2  @ BITNUM(PORTA,2); // -  , ,   DA2=1
static bit DA3  @ BITNUM(PORTA,3); //.  , 
static bit DA4  @ BITNUM(PORTA,4); // , 
static bit DA5  @ BITNUM(PORTA,5); // , 

static bit DB0  @ BITNUM(PORTB,0); // 
static bit DB1  @ BITNUM(PORTB,1); // 
static bit DB2  @ BITNUM(PORTB,2); //   . 
static bit DB3  @ BITNUM(PORTB,3); //    
static bit DB4  @ BITNUM(PORTB,4); //    
static bit DB5  @ BITNUM(PORTB,5); //    
static bit DB6  @ BITNUM(PORTB,6); //    
static bit DB7  @ BITNUM(PORTB,7); //  

static bit DC0  @ BITNUM(PORTC,0); //  
static bit DC1  @ BITNUM(PORTC,1); //  -1 -1
static bit DC2  @ BITNUM(PORTC,2); //  -2 -2
static bit DC3  @ BITNUM(PORTC,3); //  -3 -3
static bit DC4  @ BITNUM(PORTC,4); //  -4 -4
static bit DC5  @ BITNUM(PORTC,5); //  -5 -5
static bit DC6  @ BITNUM(PORTC,6); //  -6 -6
static bit DC7  @ BITNUM(PORTC,7); //  -7 -7

bit FLAG_0;         // .
bit FLAG_1;         // .
bit FLAG_2;         // .
bit FLAG_3;         // .
bit FLAG_4;         // .
bit FLAG_5;         // .
bit FLAG_6;         // .
bit FLAG_7;         // .
bit FLOG_0;         // .
bit FLOG_1;         // .
bit FLOG_2;         // .
bit FLOG_3;         // .
bit FLOG_4;         // .
bit FLOG_5;         // .
bit FLOG_6;         // .
bit FLOG_7;         // .

      int KeyStates[7] = {1,1,1,1,1,1,1};
      int KeyboardState[7] = {0,0,0,0,0,0,0};
      
      int KeyboardStateMax = 100;


   void low_init()
 {
   TRISA=0b00000000; 	
   PORTA=0b00111000;

   TRISB=0b11110111;    //	
   PORTB=0b00000000;
   RBPU = 0;  //  R (0-, 1-)

   TRISC=0b00000001; 	
   PORTC=0b11111111; 
 //*******************************************************************************

 //*******************************************************************************

   BUFREP=BUFRRP=BUFF=BUFK=BLLD=BUFI=BUFL=BUFP=BUF=0;  //
   REPREP=BUFE=BUFD=BUFC=BUFB=1;
   DREBEZ=2;

 ADCON1=0x06;   //    "" . 0000  0110
 FLAG_0=0;                // .
 FLAG_1=0;                //
 FLAG_2=0;                //
 FLAG_3=0;                //
 FLAG_4=0;                // 
 FLAG_5=0;                //
 FLAG_6=0;                //
 FLAG_7=0;                //
 FLOG_0=0;                //
 FLOG_1=0;                //
 FLOG_2=1;                //
 FLOG_3=0;                //
 FLOG_4=0;                //
 FLOG_5=0;                //
 FLOG_6=0;                //
 FLOG_7=0;                //

 }


   // unsigned int 0  65535
  // delayt   p
   void delayt(unsigned long int p)
 {
   unsigned long int J;
   unsigned char K;
   for(J=0;J<p;J++)
   for(K=0;K<20;K++)
 {
   asm("NOP");
 }
 }


 void delay(unsigned int p)
 {
   unsigned int J;
   for(J=0;J<p;J++)
 {
   asm("NOP");
 }
 }

//********************************************************
//********************************************************
    void OPROSUP(void) 
   {

   TRISA=0b00111000;

 if (DA3==0)  //
   {          //
 if (FLAG_0==0)  //
{              //
   BUFL=BUFB;
   BUFB=!BUFL;  //
   FLAG_0=1;
   }  
   }        //
else     // 
{            //
   FLAG_0=0;    //
}            //


//********************************************************
//**********************
 if (DA4==0)  //  
   {          //

  if (FLAG_1==0)   // 
   {      // 
   BUFK=BUFRRP;
   BUFRRP=!BUFK;  //
   FLAG_1=1;
 if (BUFRRP==1){BUFC=0;DB3=1;} //,   
 if (BUFRRP==0){BUFC=1;}    // .
    } //
    } //
 else     // 
  {            //

   FLAG_1=0;    //
  }            //
//**********************
//**********************

 if (DA5==0)  //
   { 
   BUFREP=1;  // 
   BUFD=0;  // 
  }     //

   TRISA=0b00000000;
  }              //
//********************************************************
//********************************************************
//********************************************************
//           
//********************************************************
    void OPROSKL(void) 
   {

   TRISC=0b11111111; 

 if (DC0==0)  //
   { 
   BUFREP=0; // 
   BUFRRP=0; // , 
   BUFD=1;
   BUFP=0;   //  
   BUFB=1;   //
   BUFK=0;
   BUF=0;
   BUFC=1;
           } //


              //    
   
   KeyStates[0] = DC1;
   KeyStates[1] = DC2;
   KeyStates[2] = DC3;
   KeyStates[3] = DC4;
   KeyStates[4] = DC5;
   KeyStates[5] = DC6;
   KeyStates[6] = DC7;
   
   for (i = 0; i < 7; i ++)
   {
      if (KeyStates[i] == 0) { 
       if (KeyboardState[i] == 0) KeyboardState[i] = KeyboardStateMax; //    
       else KeyboardState[i] = KeyboardStateMax - 1;//,  1  
                  };
      
      if (KeyboardState[i] > 0) {
        if (KeyboardState[i] == KeyboardStateMax) {

                      //  
         BUF= i + 1;              //
        }
        KeyboardState[i]--;
    }
   }
   
   TRISC=0b00000001;

   }              //
//********************************************************
//********************************************************
//********************************************************
//          
//********************************************************
    void APOISKZ(void) 
    {
   if (BUFD==0)
      {
   DA5=BUFD;  //-0 -1
 while(BUF==1||BUF==2||BUF==3||BUF==4||BUF==5||BUF==6||BUF==7)
     {       // 
 if (DC0==0||DB7==1) {BUF=0;} //, 
    
  if(DB4==0 && FLAG_7==0){DA2=1;DA1=0;FLAG_7=1;} //  
  if(DB4==1 && FLOG_0==0){DA2=0;__delay_ms(395);__delay_ms(5);FLOG_0=1;} //  ڨ
  if(DB4==1 && FLAG_4==0) {DA2=0;DA1=1;DA0=1;FLAG_4=1;} //   
   FLOG_2=0;
   FLOG_3=0;
   FLOG_1=1;

//********************************************************
//    ,   
//********************************************************
 if (DB2==0 && DA1==1 && DB5==1)  // ר     DB5=1
        {              //
  if (DREBEZ==2)  //
   {             
   BUF--;     //ר  
    DREBEZ=100;    //
              } 
               } 
  else           // 
   {             //
    DREBEZ--;
   if (DREBEZ==1) {DREBEZ=2;}    //
             }   //
//********************************************************
//********************************************************

 if(DB6==1){DB3=1;}  //  
//********************************************************
//       
//********************************************************
   DC1=DC2=DC3=DC4=DC5=DC6=DC7=1;
 if (BUF==1)  //BUF
   {         //
   DC1=0;
   }         //
 if (BUF==2)  //
   {         //
   DC2=0;
   }         //
 if (BUF==3)  //
   {         //
   DC3=0;
   }         //
 if (BUF==4)  //
   {         //
   DC4=0;
   }         //
 if (BUF==5)  //
   {         //
   DC5=0;
   }         //
 if (BUF==6)  //
   {         //
   DC6=0;
   }         //
 if (BUF==7)  //
   {         //
   DC7=0;
   }         //


//********************************************************
//********************************************************

     }       // 

   if (BUF==0 && FLOG_1==1) 
         {
           DA0=0;       //.  
           FLAG_7=0;
           FLOG_0=0;
           FLAG_4=0;
           
   if (DB5==1 && FLOG_2==0){DA0=0;DA1=0;DA2=1;FLOG_2=1;}  //DB5=1 -  
                                        //  
   if (DB5==0 && FLOG_3==0){DA2=0;FLOG_3=1;FLOG_1=0;FLOG_4=1;}  //DB5=0 -  
                                        //  
                                      }
                                 }
                            }           //
//********************************************************
//********************************************************

//********************************************************
//       
//********************************************************
    void OPRRAB(void) 
   {
 if (DB7==1){if (BUFC==1){BUFD=1;BUFREP=0;}else{FLOG_5=1;}}  //

     BLLD++;
  if (BLLD>=250)   // 4 
      {      // 
 if(DB6==1){DB3=1; if(FLOG_6==0){BUFREP=1;FLOG_6=1;}}  //  
   BLLD=249;
             } //


 if(DB6==0 && BUFC==1){DB3=0;BUFREP=0;FLOG_6=0;}  //  

 if (BUFD==0 && FLOG_4==0)  //
   { 
 if (BUFRRP==1||BUFRRP==0){  //
 if(DB4==0 && DB6==0 && BUFI==0){DA2=1;DA1=0;BUFI=1;} //  
 if(DB4==1 && DB6==0 && BUFI==1){DA2=0;DA0=1;DA1=1;BUFI=2;} //    DB4-  
                            //DA0-    
 if (DB2==0 && DB4==1 && BUFI==2){DA1=0;DA0=0;DA2=1;BUFI=3;} //    DA2- 
 if (DB5==0 && BUFI==3){DA2=0;FLOG_4=1;BUFI=0;} //  DB5-   
          }       //
        }       //

 if (BUFD==1 && BUFP==0)  //
   { 
   BUFP=0; //. 
   BUFI=0; //. 
   BUFF=0; //. 
   FLOG_4=0;


 
 if(DB4==0 && DB6==1 && BUFREP==0){DA2=1;DA1=0;BUFC=1;} // DB4-   .
 if(DB4==1 && DB6==1){DA2=1;DA1=0;DA0=1;} //    DB4-   
 if(DB6==0 && DB4==1){__delay_ms(400);DA0=0;DA2=1;DA1=0;} //     DA0-. 
 if(DB5==1 && DB4==0 && DB6==0){DA0=0;DA2=1;DA1=0;} //      . 
 if(DB5==1 && DB4==0 && DB6==1){DA2=1;DA1=0;} //       
 if (DB5==0 && DB6==0){DA2=0;} //  DB5-   
        }      //

 if (BUFC==0 && FLOG_4==1 && FLOG_5==1)  //
   { 
 if(DB4==0 && DB6==1 && BUFF==0){DA2=1;DA1=0;BUFF=1;} //  DB4-   
 if(DB4==1 && BUFF==1){DA2=1;DA1=0;DA0=1;BUFF=2;} //    DB4=1  
 if(DB6==0 && BUFF==2){DA2=0;DA1=1;BUFF=3;} //   
 if (DB2==0 && DB4==1 && BUFF==3){DA1=0;DA0=0;DA2=1;BUFF=4;} //    DA2- 
 if (DB5==0 && BUFF==4){DA2=0;BUFF=0;FLOG_5=0;} //  DB5-   
        }      //

 if (BUFB==0 && DB6==1)  // 
   { 
 if(DB4==0 && BUFP==0){DA2=1;DA1=0;BUFP=1;} //  
 if(DB4==1 && BUFP==1){DA2=0;BUFP=2;} // ڨ DB4-   
        }     // 
 if (BUFB==1 && DB6==1)  //  
{ 
 if (DB4==1 && BUFP==2){DA2=1;DA1=0;BUFP=3;} // 
 if (DB5==0 && BUFP==3){DA2=0;BUFP=0;} //  DB5-   
        } 

        }              //
//********************************************************
//********************************************************

void main ()   //  
{ //  
   low_init(); //    
    //  
while(1)  //
{ //   

         OPROSKL();   //    

        OPROSUP();   //  

         OPRRAB();   //

        APOISKZ();   //   

//********************************************************
//********************************************************
//********************************************************
//       
//********************************************************
   DC1=DC2=DC3=DC4=DC5=DC6=DC7=1;
 if (BUF==1)  //BUF
   {         //
   DC1=0;
   }         //
 if (BUF==2)  //
   {         //
   DC2=0;
   }         //
 if (BUF==3)  //
   {         //
   DC3=0;
   }         //
 if (BUF==4)  //
   {         //
   DC4=0;
   }         //
 if (BUF==5)  //
   {         //
   DC5=0;
   }         //
 if (BUF==6)  //
   {         //
   DC6=0;
   }         //
 if (BUF==7)  //
   {         //
   DC7=0;
   }         //


//********************************************************
//        2
//********************************************************


   DA3=BUFB;  // -0

//********************

//********************
 //*******************

 //*******************
//********************

 if (BUFRRP==1){DA4=BUFC;}  //  -1
 if (BUFRRP==0){DA4=BUFC;}  
//********************

   DA5=BUFD;  //-0 -1

   delayt(35);

//***********************************************************
//***********************************************************

//********************************************************
//********************************************************

} //   

} //  

//********************************************************
//********************************************************



